/**********************************************************
 *                                                        *
 *                               *
 *                                                        *
 *         *
 *     ListView.          *
 *                                                        *
 *           - *
 *        commctrl.h,  HeaderEx.h   *
 *  HeaderEx.cpp      - *
 *   comctl32.lib                                  *
 *  commctrl   InitCommonControls(). *
 *      :                    *
 * - InitListViewEx    ListView       *
 * - InitHeaderEx                *
 *                                                        *
 *       .      *
 *       '\n'*
 *                                                        *
 *          - *
 *           - *
 *   .                                     *
 *********************************************************/

#include <windows.h>
#include <commctrl.h>
#pragma comment(lib, "comctl32.lib")

#include "HeaderEx.h"



TCHAR szAppName[] = "MyTestHeaderEx";	
						
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, INT);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);

#define IDC_LIST		100



INT APIENTRY WinMain(HINSTANCE hInstance,
					 HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     INT       nCmdShow)
{
	MSG msg;

	MyRegisterClass(hInstance);
	if(!InitInstance(hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	while(GetMessage(&msg, NULL, 0, 0)) 
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return (INT)msg.wParam;
}


ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof WNDCLASSEX; 

	wcex.style			= 0;//CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC) WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= NULL;
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH) COLOR_APPWORKSPACE;
	wcex.lpszMenuName	= NULL;
	wcex.lpszClassName	= szAppName;
	wcex.hIconSm		= NULL;

	return RegisterClassEx(&wcex);
}


BOOL InitInstance(HINSTANCE hInstance, INT nCmdShow)
{
	HWND hWnd;
	
//  Common 
	InitCommonControls();
	
	hWnd = CreateWindow(szAppName, szAppName, 
		WS_OVERLAPPEDWINDOW, CW_USEDEFAULT, CW_USEDEFAULT, 
		600, 400, NULL, NULL, hInstance, NULL);

	if (!hWnd)
      return FALSE;

   ShowWindow(hWnd, SW_SHOWNORMAL);
   UpdateWindow(hWnd);

   return TRUE;
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, 
						 WPARAM wParam, LPARAM lParam)
{
	switch (uMsg) 
	{
		case WM_CREATE:
		{
			LV_COLUMN lvc;

			HWND hwndLV = CreateWindowEx(WS_EX_STATICEDGE, 
				WC_LISTVIEW, "", LVS_SHOWSELALWAYS | 
				WS_VISIBLE | WS_CHILD | LVS_REPORT | 
				LVS_SINGLESEL, 0, 0, 1, 1, hWnd, (HMENU)IDC_LIST, 
				(HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE),
				NULL);

		//  . header'
			InitListViewEx(hwndLV);

		//    
			ListView_SetExtendedListViewStyle(hwndLV,
				WS_EX_STATICEDGE |
				LVS_EX_HEADERDRAGDROP |
				LVS_EX_FULLROWSELECT);

			lvc.iSubItem = 0;
			lvc.mask = LVCF_FMT | LVCF_WIDTH | 
				LVCF_TEXT | LVCF_SUBITEM;
			lvc.fmt = LVCFMT_LEFT;

			lvc.iSubItem++;
			lvc.cx = 30; 
			lvc.pszText = " /";
			ListView_InsertColumn(hwndLV, lvc.iSubItem, &lvc);

			lvc.iSubItem++;
			lvc.cx = 70;
			lvc.pszText = "\n";
			ListView_InsertColumn(hwndLV, lvc.iSubItem, &lvc);

			lvc.iSubItem++;
			lvc.cx = 70;
			lvc.pszText = "\n";
			ListView_InsertColumn(hwndLV, lvc.iSubItem, &lvc);

			lvc.iSubItem++;
			lvc.cx = 70;
			lvc.pszText = "\n";
			ListView_InsertColumn(hwndLV, lvc.iSubItem, &lvc);

			lvc.iSubItem++;
			lvc.cx = 130;
			lvc.pszText = "\n\nemail";
			ListView_InsertColumn(hwndLV, lvc.iSubItem, &lvc);

			lvc.iSubItem++;
			lvc.cx = 50;
			lvc.pszText = "\n\nICQ";
			ListView_InsertColumn(hwndLV, lvc.iSubItem, &lvc);

			lvc.iSubItem++;
			lvc.cx = 70;
			lvc.pszText = "\n\n";
			ListView_InsertColumn(hwndLV, lvc.iSubItem, &lvc);

			lvc.iSubItem++;
			lvc.cx = 80;
			lvc.pszText = "\n\n";
			ListView_InsertColumn(hwndLV, lvc.iSubItem, &lvc);


			LVITEM lvi;
			lvi.mask = LVIF_TEXT;
			lvi.iItem = 0;
			lvi.iSubItem = 0;
			lvi.pszText = "1";
			lvi.iItem = ListView_InsertItem(hwndLV, &lvi);

			lvi.iSubItem++;
			lvi.pszText = "";
			ListView_SetItem(hwndLV, &lvi);

			lvi.iSubItem++;
			lvi.pszText = "";
			ListView_SetItem(hwndLV, &lvi);

			lvi.iSubItem++;
			lvi.pszText = "Pete";
			ListView_SetItem(hwndLV, &lvi);

			lvi.iSubItem++;
			lvi.pszText = "petepup@mymail.com";
			ListView_SetItem(hwndLV, &lvi);

			lvi.iSubItem++;
			lvi.pszText = "911";
			ListView_SetItem(hwndLV, &lvi);

			lvi.iSubItem++;
			lvi.pszText = "Russia";
			ListView_SetItem(hwndLV, &lvi);

			lvi.iSubItem++;
			lvi.pszText = "Great village";
			ListView_SetItem(hwndLV, &lvi);


			lvi.iItem++;
			lvi.iSubItem = 0;
			lvi.pszText = "2";
			lvi.iItem = ListView_InsertItem(hwndLV, &lvi);

			lvi.iSubItem++;
			lvi.pszText = "";
			ListView_SetItem(hwndLV, &lvi);

			lvi.iSubItem++;
			lvi.pszText = "Unknown";
			ListView_SetItem(hwndLV, &lvi);

			lvi.iSubItem++;
			lvi.pszText = "Vovan";
			ListView_SetItem(hwndLV, &lvi);

			lvi.iSubItem++;
			lvi.pszText = "vovan@supermail.com";
			ListView_SetItem(hwndLV, &lvi);

			lvi.iSubItem++;
			lvi.pszText = "none";
			ListView_SetItem(hwndLV, &lvi);

			lvi.iSubItem++;
			lvi.pszText = "Russia";
			ListView_SetItem(hwndLV, &lvi);

			lvi.iSubItem++;
			lvi.pszText = "Tiny city";
			ListView_SetItem(hwndLV, &lvi);
		}
		break;
		case WM_DESTROY:
			PostQuitMessage(0);
		break;

		case WM_GETMINMAXINFO:
		{
			POINT ps = {300, 100};
			((LPMINMAXINFO)lParam)->ptMinTrackSize = ps;
		}
		break;

		case WM_SIZE:
		{
			RECT r; GetClientRect(hWnd, &r);
			HWND hwndLV = GetDlgItem(hWnd, IDC_LIST);
			MoveWindow(hwndLV, r.left, r.top,
				r.right-r.left, r.bottom-r.left,
				TRUE);
		}
		break;
   }

   return DefWindowProc(hWnd, uMsg, wParam, lParam);
}
